#pragma once
#include <math.h>
#include "cmscp.h"
#include "denseBlas.h"

#define PI 3.141592653589793
void rot_x(demat* M, double alf);
void rot_y(demat* M, double alf);
void rot_z(demat* M, double alf);
void C_A2B(demat* M, double phi_T, double psi_T, double gamma_T);
void C_A2O(demat* M, double A0, double phi0, double T);
void C_En2T(demat* M, double phi0, double phi, double dlambda);
void C_H2B(demat* M, double nv, double beta, double alpha);
void C_O2E(demat* M, double A0, double phi0);
void C_O2En(demat* M, double A0);
void C_T2H(demat* M, double sigma, double theta);
void C_V2B(demat* M, double beta, double alpha);
void A_H2B1(double* alpha, double* beta, double* nu,
	double sigma, double theta,
	double lat, double lon,
	double phi_T, double psi_T, double gamma_T,
	double A0, double lon0, double phi0, double T);