#include "dynInteg.h"

void dynInteg1(double* dynRhs, double* path, double* x, double* u, double* p, cmscp_auxdata* auxdata) {
	// ж¹̬ǿ
	// x״̬ľࡢȡγȡٶȡٶǡĵغλǡʱ
	// uԷϵĸƫ

	double A0, lon0, B0, alpha, beta, nu, u1[4] = { 0 }, dynRhs0[8] = { 0 }, path0[5] = { 0 }, state[8] = { 0 };
	cmscp_scales* scales;

	scales = auxdata->scales;
	A0 = auxdata->launchA;
	lon0 = auxdata->launchLon;
	B0 = auxdata->launchB;

	// ٻ
	state[0] = x[0] * scales->length;
	state[1] = x[1];
	state[2] = x[2];
	state[3] = x[3] * scales->speed;
	state[4] = x[4];
	state[5] = x[5];
	state[6] = x[6] * scales->mass;
	state[7] = x[7] * scales->time;

	// Ʊ
	A_H2B1(&alpha, &beta, &nu,
		state[5], state[4], state[2], state[1], u[0], u[1], auxdata->gammaT0,
		A0, lon0, B0, state[7]);
	u1[0] = auxdata->thrust;
	u1[1] = alpha;
	u1[2] = beta;
	u1[3] = nu;

	// ѧ
	dynamics0(dynRhs0, path0, state, u1, auxdata);

	// ٻ
	// ѧֱ(пdynRhsdynRhs0һ)
	if (dynRhs != NULL)
	{
		dynRhs[0] = dynRhs0[0] / scales->speed;
		dynRhs[1] = dynRhs0[1] * scales->time;
		dynRhs[2] = dynRhs0[2] * scales->time;
		dynRhs[3] = dynRhs0[3] / scales->acceleration;
		dynRhs[4] = dynRhs0[4] * scales->time;
		dynRhs[5] = dynRhs0[5] * scales->time;
		dynRhs[6] = dynRhs0[6] / scales->mass * scales->time;
		dynRhs[7] = dynRhs0[7];
	}

	// ·Լֵ
	if (path != NULL) {
		path[0] = path0[0] / scales->length;//߶
		path[1] = path0[1] / (scales->density * scales->speed * scales->speed);//ѹ
		path[2] = path0[2];//
		path[3] = path0[3];//ݳ̽
		path[4] = path0[4];//̽
	}
}

void dynInteg2(double* dynRhs, double* path, double* x, double* u, double* p, cmscp_auxdata* auxdata) {
	// ޶¹̬ǿ
	// x״̬ľࡢȡγȡٶȡٶǡĵغλǡʱ
	// uԷϵĸƫ

	double A0, lon0, B0, u1[4] = { 0 }, dynRhs0[8] = { 0 }, path0[5] = { 0 }, state[8] = { 0 };
	cmscp_scales* scales;

	scales = auxdata->scales;
	A0 = auxdata->launchA;
	lon0 = auxdata->launchLon;
	B0 = auxdata->launchB;

	// ٻ
	state[0] = x[0] * scales->length;
	state[1] = x[1];
	state[2] = x[2];
	state[3] = x[3] * scales->speed;
	state[4] = x[4];
	state[5] = x[5];
	state[6] = x[6] * scales->mass;
	state[7] = x[7] * scales->time;

	// ѧ
	dynamics0(dynRhs0, path0, state, u1, auxdata);

	// ٻ
	// ѧֱ
	if (dynRhs!=NULL)
	{
		dynRhs[0] = dynRhs0[0] / scales->speed;
		dynRhs[1] = dynRhs0[1] * scales->time;
		dynRhs[2] = dynRhs0[2] * scales->time;
		dynRhs[3] = dynRhs0[3] / scales->acceleration;
		dynRhs[4] = dynRhs0[4] * scales->time;
		dynRhs[5] = dynRhs0[5] * scales->time;
		dynRhs[6] = dynRhs0[6] / scales->mass * scales->time;
		dynRhs[7] = dynRhs0[7];
	}

	// ·Լֵ
	if (path != NULL) {
		path[0] = path0[0] / scales->length;//߶
		path[1] = path0[1] / (scales->density * scales->speed * scales->speed);//ѹ
		path[2] = path0[2];//
		path[3] = path0[3];//ݳ̽
		path[4] = path0[4];//̽
	}
}


void dynInteg3(double* dynRhs, double* path, double* x, double* u, double* p, cmscp_auxdata* auxdata) {
	// 붯ѧģͣΪƱ
	// x״̬ľࡢȡγȡٶȡٶǡĵغλǡʱ
	// u

	double A0, lon0, B0, u1[4] = { 0 }, dynRhs0[8] = { 0 }, path0[5] = { 0 }, state[8] = { 0 };
	cmscp_scales* scales;

	scales = auxdata->scales;
	A0 = auxdata->launchA;
	lon0 = auxdata->launchLon;
	B0 = auxdata->launchB;

	// ٻ
	state[0] = x[0] * scales->length;
	state[1] = x[1];
	state[2] = x[2];
	state[3] = x[3] * scales->speed;
	state[4] = x[4];
	state[5] = x[5];
	state[6] = x[6] * scales->mass;
	state[7] = x[7] * scales->time;

	// Ʊ
	u1[3] = u[0];

	// ѧ
	dynamics0(dynRhs0, path0, state, u1, auxdata);

	// ٻ
	// ѧֱ
	if (dynRhs != NULL)
	{
		dynRhs[0] = dynRhs0[0] / scales->speed;
		dynRhs[1] = dynRhs0[1] * scales->time;
		dynRhs[2] = dynRhs0[2] * scales->time;
		dynRhs[3] = dynRhs0[3] / scales->acceleration;
		dynRhs[4] = dynRhs0[4] * scales->time;
		dynRhs[5] = dynRhs0[5] * scales->time;
		dynRhs[6] = dynRhs0[6] / scales->mass * scales->time;
		dynRhs[7] = dynRhs0[7];
	}

	// ·Լֵ
	if (path != NULL) {
		path[0] = path0[0] / scales->length;//߶
		path[1] = path0[1] / (scales->density * scales->speed * scales->speed);//ѹ
		path[2] = path0[2];//
		path[3] = path0[3];//ݳ̽
		path[4] = path0[4];//̽
	}
}