#pragma once
#include "example1.h"
#include "cmscp.h"
#include "denseBlas.h"
#include "coordinates.h"
#include "dynInteg.h"
#include "numericalFunctions.h"
#include "constaints.h"
#include <limits.h>


void getIniRefTraj(cmscp_trajInfo** refTraj, cmscp_setup* setup);
int stopCondition(int iIter, cmscp_trajInfo** refTraj, cmscp_trajInfo** optTraj, cmscp_setup* setup);
void updateMeshInfo(int iIter, cmscp_trajInfo** refTraj, cmscp_trajInfo** optTraj, cmscp_setup* setup);
void updateTrustInfo(int iIter, cmscp_trajInfo** refTraj, cmscp_trajInfo** optTraj, cmscp_setup* setup);
void updateRefTraj(cmscp_trajInfo** refTraj, cmscp_trajInfo** optTraj, cmscp_setup* setup);

void getObjEventDepend(intDemat* dependMatrix);
void getContDepend(intDemat* dependMatrix, int iphase, cmscp_setup* setup);
void getEndpDepend(intDemat* dependMatrix, int iphase, cmscp_setup* setup);
void getLinkDepend(intDemat* dependMatrix, int iphase, cmscp_setup* setup);






