/**
 * @file tool_time.h
 * @brief 实现计时器
 * This file implements timer.
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * \note Notice that this module is needed only during development, and should be disabled
 * when used in production.
 *
 * This module serves as utility module, don't waste time in reading it.
 */

#ifndef __TOOL_TIME_H__
#define __TOOL_TIME_H__

#include "csocp_config.h"

/** 获取运行时间 Get the elapsed time */
c_real c_timer_elapsed();

#endif
