/**
 * This file implements routines for scaling methods in CSOCP solver
 *
 * This module serves as part of presolving module
 */

#ifndef __CSOCP_SCALING_H__
#define __CSOCP_SCALING_H__

#include "csocp_config.h"

/* Scale the problem */
void c_scaling_set(csocp_prob *prob /* The CSOCP problem */
);

/* Unscale the problem */
void c_scaling_unset(csocp_prob *prob /* The CSOCP problem */
);

#endif
