/**
 * This file implements interrupt handling for the CSOCP solver.
 *
 * Notice that this module is needed only during development, and should be disabled
 * when used in production.
 *
 * This module serves as utility module, don't waste time in reading it.
 *
 * To enable this module, just define macro 'CSOCP_WITH_INTERRUPT' when compiling it;
 * othewise, it is disabled.
 */

#ifndef __TOOL_INTERRUPT_H__
#define __TOOL_INTERRUPT_H__

/* Create interrupt handler */
void c_interrupt_register(void);

/* Remove interrupt handler */
void c_interrupt_reset(void);

/* Check for interrupt action */
int c_interrupt_check(void);

#endif
