/**
 * This file implements message print module in CSOCP solver
 */

#ifndef __TOOL_PRINT_H__
#define __TOOL_PRINT_H__

#ifdef CSOCP_WITH_PRINT
#include <stdio.h>
#ifdef MATLAB_MEX_FILE
#include "mex.h"
#define c_print mexPrintf
#define c_fprint fprintf
#else
#define c_print printf
#define c_fprint fprintf
#endif
#else
#define c_print(...)
#define c_fprint(...)
#endif

#endif
