#pragma once

#include "cmscp.h"
#include "cmscp_math.h"
#include <math.h>
/* ṹ */

typedef struct cmscp_type {
	int num; //typeֶnumidxnumʾԼڸԼĸidx¼ڸ÷ԼڸԼ
	int* idx;
}cmscp_type;

typedef struct cmscp_consType {
	cmscp_type type[4];  // consTypeа4ṹ壬ζӦ1~4ԼϢ1: ˫߲ʽԼ, 2:ʽԼ, 3:ϵ߲ʽԼ, 4:µ߲ʽԼ
}cmscp_consType;

typedef struct cmscp_consType_bound {
	cmscp_consType** iniTime;
	cmscp_consType** finTime;
	cmscp_consType** iniState;
	cmscp_consType** state;
	cmscp_consType** finState;
	cmscp_consType** control;
	cmscp_consType** parameter;
}cmscp_consType_bound;

typedef struct cmscp_consTypeInfo {
	cmscp_consType** endp;
	cmscp_consType** path;
	cmscp_consType_bound* bound;
	cmscp_consType** link;
	cmscp_consType* event;
}cmscp_consTypeInfo;


/*  */
void getConsTypeInfo(cmscp_consTypeInfo** consTypeInfo, cmscp_setup* setup);
void mallocConsTypeInfo(cmscp_consTypeInfo** consTypeInfo0, int numPhase); // ԼϢڴռ
void consTypeInfoEndp(cmscp_consTypeInfo** consTypeInfo0, cmscp_setup* setup); //ζ˵Լ
void consTypeInfoPath(cmscp_consTypeInfo** consTypeInfo0, cmscp_setup* setup); // ·Լ
void consTypeInfoBound(cmscp_consTypeInfo** consTypeInfo0, cmscp_setup* setup); // α߽Լ
void consTypeInfoEvent(cmscp_consTypeInfo** consTypeInfo0, cmscp_setup* setup); // ¼Լ
void consTypeInfoLink(cmscp_consTypeInfo** consTypeInfo0, cmscp_setup* setup); // νԼ


#include "cmscp_socpInfo.h"
int getType1EventNnz(cmscp_type consType1, cmscp_nzPos_endp** nzPos, int numPhase);
int getType1EndpNnz(cmscp_type consType1, cmscp_nzPos_endp* nzPos);
int getType1PathNnz(cmscp_type consType1, cmscp_nzPos_cont* nzPos, int numState);
int getType1LinkNnz(cmscp_type consType1, cmscp_nzPos_link* nzPos);