#pragma once

#include "cmscp.h"
#include "cmscp_math.h"
#include "cmscp_sparseInfo.h"
#include "cmscp_consTypeInfo.h"
#include "gradInfoFunctions.h"

/* ṹ */
typedef struct cmscp_dimCone {
	int l;
	int nsoc;
	int* q;
}cmscp_dimCone;
typedef struct cmscp_socpInfo {
	int numOptVar; // Ż
	int* numPhaseOptVar; // һŻλ
	double* c; // Ŀ꺯
	int cntNzAEqua; // ʽԼԪؼ
	int cntRowAEqua; // ʽԼм
	int cntNzAIneq; // ʽԼԪؼ
	int cntRowAIneq; // ʽԼм
	int cntNzASoc; // ׶ԼԪؼ
	int cntRowASoc; // ׶Լм
	int cntSubASoc; // ׶Լ׶
	cmscp_crsSpmat* AEqua;
	cmscp_ccsSpmat* AEqua1;
	double* bEqua;
	cmscp_crsSpmat* ACone;
	cmscp_ccsSpmat* ACone1;
	double* bCone;
	cmscp_dimCone* dimCone;
}cmscp_socpInfo;

void getSocpInfo(cmscp_socpInfo** socpInfo, cmscp_trajInfo** refTraj, cmscp_sparseInfo* sparseInfo, cmscp_consTypeInfo* consTypeInfo, cmscp_setup* setup); // ȡ׶滮Ĳ

void socpInfoSparseDim(cmscp_socpInfo** socpInfo0, cmscp_consTypeInfo* consTypeInfo, cmscp_sparseInfo* sparseInfo, cmscp_setup* setup); // ȡ׶滮ĲάԼӦĿռ

void socpInfoSparseObjEvent(cmscp_socpInfo** socpInfo0, cmscp_trajInfo** refTraj, cmscp_sparseInfo* sparseInfo, cmscp_consTypeInfo* consTypeInfo, cmscp_setup* setup);

void socpInfoSparseEndp(cmscp_socpInfo** socpInfo0, cmscp_trajInfo** refTraj, cmscp_sparseInfo* sparseInfo, cmscp_consTypeInfo* consTypeInfo, cmscp_setup* setup);

void socpInfoSparseLink(cmscp_socpInfo** socpInfo0, cmscp_trajInfo** refTraj, cmscp_sparseInfo* sparseInfo, cmscp_consTypeInfo* consTypeInfo, cmscp_setup* setup);

void socpInfoBound(cmscp_socpInfo** socpInfo0, cmscp_consTypeInfo* consTypeInfo, cmscp_setup* setup);

void socpInfoTrust(cmscp_socpInfo** socpInfo0, cmscp_trajInfo** refTraj, cmscp_setup* setup);