#include "freeConsTypeInfo.h"
void freeConsTypeInfo(cmscp_consTypeInfo** consTypeInfo0, cmscp_setup* setup)
{
	int iphase, iType;
	cmscp_consTypeInfo* consTypeInfo;
	consTypeInfo = *consTypeInfo0;
	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		for (iType = 0; iType < 4; iType++)
		{
			if (consTypeInfo->endp[iphase]->type[iType].idx)
			{
				free(consTypeInfo->endp[iphase]->type[iType].idx);
			}
		}
		free(consTypeInfo->endp[iphase]);
	}
	free(consTypeInfo->endp);

	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		for (iType = 0; iType < 4; iType++)
		{
			if (consTypeInfo->path[iphase]->type[iType].idx)
			{
				free(consTypeInfo->path[iphase]->type[iType].idx);
			}
		}
		free(consTypeInfo->path[iphase]);
	}
	free(consTypeInfo->path);
	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		for (iType = 0; iType < 4; iType++)
		{
			if (consTypeInfo->bound->iniTime[iphase]->type[iType].idx)
			{
				free(consTypeInfo->bound->iniTime[iphase]->type[iType].idx);
			}
			if (consTypeInfo->bound->finTime[iphase]->type[iType].idx)
			{
				free(consTypeInfo->bound->finTime[iphase]->type[iType].idx);
			}
			if (consTypeInfo->bound->iniState[iphase]->type[iType].idx)
			{
				free(consTypeInfo->bound->iniState[iphase]->type[iType].idx);
			}
			if (consTypeInfo->bound->finState[iphase]->type[iType].idx)
			{
				free(consTypeInfo->bound->finState[iphase]->type[iType].idx);
			}
			if (consTypeInfo->bound->state[iphase]->type[iType].idx)
			{
				free(consTypeInfo->bound->state[iphase]->type[iType].idx);
			}
			if (consTypeInfo->bound->control[iphase]->type[iType].idx)
			{
				free(consTypeInfo->bound->control[iphase]->type[iType].idx);
			}
			if (consTypeInfo->bound->parameter[iphase]->type[iType].idx)
			{
				free(consTypeInfo->bound->parameter[iphase]->type[iType].idx);
			}
		}
		free(consTypeInfo->bound->iniTime[iphase]);
		free(consTypeInfo->bound->finTime[iphase]);
		free(consTypeInfo->bound->iniState[iphase]);
		free(consTypeInfo->bound->finState[iphase]);
		free(consTypeInfo->bound->state[iphase]);
		free(consTypeInfo->bound->control[iphase]);
		free(consTypeInfo->bound->parameter[iphase]);
	}
	free(consTypeInfo->bound->iniTime);
	free(consTypeInfo->bound->finTime);
	free(consTypeInfo->bound->iniState);
	free(consTypeInfo->bound->finState);
	free(consTypeInfo->bound->state);
	free(consTypeInfo->bound->control);
	free(consTypeInfo->bound->parameter);
	free(consTypeInfo->bound);

	for (iType = 0; iType < 4; iType++)
	{
		if (consTypeInfo->event->type[iType].idx)
		{
			free(consTypeInfo->event->type[iType].idx);
		}
	}
	free(consTypeInfo->event);

	for (iphase = 0; iphase < setup->numPhase - 1; iphase++)
	{
		for (iType = 0; iType < 4; iType++)
		{
			if (consTypeInfo->link[iphase]->type[iType].idx)
			{
				free(consTypeInfo->link[iphase]->type[iType].idx);
			}
		}
		free(consTypeInfo->link[iphase]);
	}
	free(consTypeInfo->link);
	free(consTypeInfo);
}