#include "freeSetup.h"
void freeSetup(cmscp_setup** setup0)
{
	int iphase;
	cmscp_setup* setup;
	setup = *setup0;
	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		free(setup->bounds->phase[iphase]->initialtime);
		free(setup->bounds->phase[iphase]->finaltime);
		free(setup->bounds->phase[iphase]->initialstate->lower);
		free(setup->bounds->phase[iphase]->initialstate->upper);
		free(setup->bounds->phase[iphase]->initialstate);
		free(setup->bounds->phase[iphase]->finalstate->lower);
		free(setup->bounds->phase[iphase]->finalstate->upper);
		free(setup->bounds->phase[iphase]->finalstate);
		free(setup->bounds->phase[iphase]->state->lower);
		free(setup->bounds->phase[iphase]->state->upper);
		free(setup->bounds->phase[iphase]->state);
		free(setup->bounds->phase[iphase]->control->lower);
		free(setup->bounds->phase[iphase]->control->upper);
		free(setup->bounds->phase[iphase]->control);
		free(setup->bounds->phase[iphase]->parameter->lower);
		free(setup->bounds->phase[iphase]->parameter->upper);
		free(setup->bounds->phase[iphase]->parameter);
		free(setup->bounds->phase[iphase]->path->nl->lower);
		free(setup->bounds->phase[iphase]->path->nl->upper);
		free(setup->bounds->phase[iphase]->path->nl);
		free(setup->bounds->phase[iphase]->path->soc);
		free(setup->bounds->phase[iphase]->path);
		free(setup->bounds->phase[iphase]->endpoint->nl->lower);
		free(setup->bounds->phase[iphase]->endpoint->nl->upper);
		free(setup->bounds->phase[iphase]->endpoint->nl);
		free(setup->bounds->phase[iphase]->endpoint->soc);
		free(setup->bounds->phase[iphase]->endpoint);
		if (iphase < setup->numPhase - 1)
		{
			free(setup->bounds->phase[iphase]->linkage->nl->lower);
			free(setup->bounds->phase[iphase]->linkage->nl->upper);
			free(setup->bounds->phase[iphase]->linkage->nl);
			free(setup->bounds->phase[iphase]->linkage->soc);
			free(setup->bounds->phase[iphase]->linkage);
		}
		free(setup->bounds->phase[iphase]);
	}
	free(setup->bounds->phase);
	free(setup->bounds->event->nl->lower);
	free(setup->bounds->event->nl->upper);
	free(setup->bounds->event->nl);
	free(setup->bounds->event->soc);
	free(setup->bounds->event);
	free(setup->bounds);


	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		free(setup->dimension->phase[iphase]->path->soc->q);
		free(setup->dimension->phase[iphase]->path->soc);
		free(setup->dimension->phase[iphase]->path);
		free(setup->dimension->phase[iphase]->endpoint->soc->q);
		free(setup->dimension->phase[iphase]->endpoint->soc);
		free(setup->dimension->phase[iphase]->endpoint);
		if (iphase < setup->numPhase - 1)
		{
			free(setup->dimension->phase[iphase]->linkage->soc->q);
			free(setup->dimension->phase[iphase]->linkage->soc);
			free(setup->dimension->phase[iphase]->linkage);
		}
		free(setup->dimension->phase[iphase]);
	}
	free(setup->dimension->phase);
	free(setup->dimension->event->soc->q);
	free(setup->dimension->event->soc);
	free(setup->dimension->event);
	free(setup->dimension);

	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		free(setup->mesh[iphase]->node);
		free(setup->mesh[iphase]);
	}
	free(setup->mesh);

	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		free(setup->functions->phase[iphase]);

	}
	free(setup->functions->phase);
	free(setup->functions);

	for (iphase = 0; iphase < setup->numPhase; iphase++)
	{
		free(setup->trust->phase[iphase]->weight->control);
		free(setup->trust->phase[iphase]->weight->state);
		free(setup->trust->phase[iphase]->weight->parameter);
		free(setup->trust->phase[iphase]->weight);
		free(setup->trust->phase[iphase]);
	}
	free(setup->trust->phase);
	free(setup->trust);

	free(setup->scpInfo->solver);
	free(setup->scpInfo->obj);
	free(setup->scpInfo);
	free(setup);
}