#include "freeTrajInfo.h"

void freeTrajInfo(cmscp_trajInfo** traj, cmscp_setup* setup, int level)
{
	// ͷcmscp_trajInfoṹռ
	// level Ϊ 0 ʱֻͷ2µڴ
	// level  0 ʱȫͷ
	int iphase;
	if (traj)
	{
		if (level >= 0)
		{
			for (iphase = 0; iphase < setup->numPhase; iphase++)
			{
				freeTrajInfoPhase(traj, setup, iphase);
			}
		}
		if (level > 0)
		{
			free(traj);
		}
	}

}

void freeTrajInfoPhase(cmscp_trajInfo** traj, cmscp_setup* setup, int iphase)
{
	if (traj[iphase])
	{
		if (traj[iphase]->control)
		{
			if (traj[iphase]->control->v)
			{
				free(traj[iphase]->control->v);
			}
			free(traj[iphase]->control);
		}
		if (traj[iphase]->state)
		{
			if (traj[iphase]->state->v)
			{
				free(traj[iphase]->state->v);
			}
			free(traj[iphase]->state);
		}
		if (traj[iphase]->parameter)
		{
			free(traj[iphase]->parameter);
		}
		free(traj[iphase]);
	}
}