#pragma once
#include "cmscp.h"
#include "cmscp_math.h"
#include "cmscp_sparseInfo.h"
#include "cmscp_consTypeInfo.h"

typedef struct cmscp_derInfo {
	double* ref; // ڸ㴦ֵ
	double* der; // ڸ㴦ĵ
}cmscp_derInfo;


void gradInfoSparseObjEvent(cmscp_derInfo** objDerInfo0, cmscp_derInfo** eventDerInfo0, cmscp_sparseInfo* sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup);
void gradInfoSparseEndp(cmscp_derInfo** gradInfo, cmscp_sparseInfo* sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup);
void copyObjEventInput(cmscp_objEventInput* x, cmscp_objEventInput* y, cmscp_setup* setup);
void copyEndpInput(cmscp_endpInput* x, cmscp_endpInput* y, int iphase, cmscp_setup* setup);
void gradInfoSparseCont(cmscp_derInfo** dynGradInfo0, cmscp_derInfo** pathGradInfo0, double* refState, double* refControl, double* refParameter,
	int* stateNzIdxRow, int* controlNzIdxRow, int* parameterNzIdxRow, int* stateNzPtrCol, int* controlNzPtrCol, int* parameterNzPtrCol,
	int numState, int numControl, int numParameter, int numPathOutput, int iphase, cmscp_setup* setup);
void copyContInput(cmscp_contInput* x, cmscp_contInput* y, int numState, int numControl, int numParameter, cmscp_setup* setup);
void gradInfoSparseLink(cmscp_derInfo** gradInfo, cmscp_sparseInfo* sparseInfo, cmscp_trajInfo** refTraj, cmscp_setup* setup);
void copyLinkInput(cmscp_linkInput* x, cmscp_linkInput* y, int iphase, cmscp_setup* setup);