#include "mallocStruct.h"
/* ڴĺ */
void mallocBound(cmscp_bound* bounds, int numPhase, int numEventNl, int numRowEventSoc) {
	/*bound = (cmscp_bound*)malloc(sizeof(cmscp_bound));*/
	bounds->phase = (cmscp_boundPhase**)malloc(numPhase * sizeof(cmscp_boundPhase*));
	bounds->event = (cmscp_boundcone*)malloc(sizeof(cmscp_boundcone));
	bounds->event->nl = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->event->nl->lower = (double*)malloc(numEventNl * sizeof(double));
	bounds->event->nl->upper = (double*)malloc(numEventNl * sizeof(double));
	bounds->event->soc = (double*)malloc(numRowEventSoc * sizeof(double));
}

void mallocBoundPhase(cmscp_bound* bounds, int iphase, int numState, int numControl, int numParameter, int numPathNl, int numRowPathSoc, int numEndpNl, int numRowEndpSoc, int numLinkNl, int numRowLinkSoc, int numPhase) {
	bounds->phase[iphase] = (cmscp_boundPhase*)malloc(sizeof(cmscp_boundPhase));
	bounds->phase[iphase]->initialtime = (cmscp_boundscale*)malloc(sizeof(cmscp_boundscale));
	bounds->phase[iphase]->finaltime = (cmscp_boundscale*)malloc(sizeof(cmscp_boundscale));
	bounds->phase[iphase]->initialstate = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->phase[iphase]->initialstate->lower = (double*)malloc(numState * sizeof(double));
	bounds->phase[iphase]->initialstate->upper = (double*)malloc(numState * sizeof(double));
	bounds->phase[iphase]->finalstate = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->phase[iphase]->finalstate->lower = (double*)malloc(numState * sizeof(double));
	bounds->phase[iphase]->finalstate->upper = (double*)malloc(numState * sizeof(double));
	bounds->phase[iphase]->state = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->phase[iphase]->state->lower = (double*)malloc(numState * sizeof(double));
	bounds->phase[iphase]->state->upper = (double*)malloc(numState * sizeof(double));
	bounds->phase[iphase]->control = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->phase[iphase]->control->lower = (double*)malloc(numControl * sizeof(double));
	bounds->phase[iphase]->control->upper = (double*)malloc(numControl * sizeof(double));
	bounds->phase[iphase]->parameter = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->phase[iphase]->parameter->lower = (double*)malloc(numParameter * sizeof(double));
	bounds->phase[iphase]->parameter->upper = (double*)malloc(numParameter * sizeof(double));
	bounds->phase[iphase]->path = (cmscp_boundcone*)malloc(sizeof(cmscp_boundcone));
	bounds->phase[iphase]->path->nl = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->phase[iphase]->path->nl->lower = (double*)malloc(numPathNl * sizeof(double));
	bounds->phase[iphase]->path->nl->upper = (double*)malloc(numPathNl * sizeof(double));
	bounds->phase[iphase]->path->soc = (double*)malloc(numRowPathSoc * sizeof(double));
	bounds->phase[iphase]->endpoint = (cmscp_boundcone*)malloc(sizeof(cmscp_boundcone));
	bounds->phase[iphase]->endpoint->nl = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
	bounds->phase[iphase]->endpoint->nl->lower = (double*)malloc(numEndpNl * sizeof(double));
	bounds->phase[iphase]->endpoint->nl->upper = (double*)malloc(numEndpNl * sizeof(double));
	bounds->phase[iphase]->endpoint->soc = (double*)malloc(numRowEndpSoc * sizeof(double));
	if (iphase< numPhase-1)
	{
		bounds->phase[iphase]->linkage = (cmscp_boundcone*)malloc(sizeof(cmscp_boundcone));
		bounds->phase[iphase]->linkage->nl = (cmscp_boundvec*)malloc(sizeof(cmscp_boundvec));
		bounds->phase[iphase]->linkage->nl->lower = (double*)malloc(numLinkNl * sizeof(double));
		bounds->phase[iphase]->linkage->nl->upper = (double*)malloc(numLinkNl * sizeof(double));
		bounds->phase[iphase]->linkage->soc = (double*)malloc(numRowLinkSoc * sizeof(double));
	}
}

void mallocDimension(cmscp_dimension* dimension, int numPhase, int numEventSoc) {
	dimension->phase = (cmscp_dimensionPhase**)malloc(numPhase * sizeof(cmscp_dimensionPhase*));
	dimension->event = (cmscp_dimension2*)malloc(sizeof(cmscp_dimension2));
	dimension->event->soc = (cmscp_dimension1*)malloc(sizeof(cmscp_dimension1));
	dimension->event->soc->q = (int*)malloc(numEventSoc * sizeof(int));
}

void mallocDimensionPhase(cmscp_dimension* dimension, int iphase, int numPathSoc, int numEndpSoc, int numLinkSoc, int numPhase) {
	dimension->phase[iphase] = (cmscp_dimensionPhase*)malloc(sizeof(cmscp_dimensionPhase));
	dimension->phase[iphase]->path = (cmscp_dimension2*)malloc(sizeof(cmscp_dimension2));
	dimension->phase[iphase]->path->soc = (cmscp_dimension1*)malloc(sizeof(cmscp_dimension1));
	dimension->phase[iphase]->path->soc->q = (int*)malloc(numPathSoc * sizeof(int));
	dimension->phase[iphase]->endpoint = (cmscp_dimension2*)malloc(sizeof(cmscp_dimension2));
	dimension->phase[iphase]->endpoint->soc = (cmscp_dimension1*)malloc(sizeof(cmscp_dimension1));
	dimension->phase[iphase]->endpoint->soc->q = (int*)malloc(numEndpSoc * sizeof(int));
	if (iphase < numPhase - 1)
	{
		dimension->phase[iphase]->linkage = (cmscp_dimension2*)malloc(sizeof(cmscp_dimension2));
		dimension->phase[iphase]->linkage->soc = (cmscp_dimension1*)malloc(sizeof(cmscp_dimension1));
		dimension->phase[iphase]->linkage->soc->q = (int*)malloc(numLinkSoc * sizeof(int));
	}

}

void mallocTrust(cmscp_trust* trust, int numPhase) {
	trust->phase = (cmscp_trustPhase**)malloc(numPhase * sizeof(cmscp_trustPhase*));
}
void mallocTrustPhase(cmscp_trust* trust, int iphase, int numState, int numControl, int numParameter) {
	trust->phase[iphase] = (cmscp_trustPhase*)malloc(sizeof(cmscp_trustPhase));
	trust->phase[iphase]->weight = (cmscp_trustWeihgt*)malloc(sizeof(cmscp_trustWeihgt));
	trust->phase[iphase]->weight->state = (double*)malloc(numState * sizeof(double));
	trust->phase[iphase]->weight->control = (double*)malloc(numControl * sizeof(double));
	trust->phase[iphase]->weight->parameter = (double*)malloc(numParameter * sizeof(double));
}

void mallocFunctions(cmscp_functions* functions, int numPhase) {
	functions->phase = (cmscp_functionsPhase**)malloc(numPhase * sizeof(cmscp_functionsPhase*));
}

void mallocFunctionsPhase(cmscp_functions* functions, int iphase) {
	functions->phase[iphase] = (cmscp_functionsPhase*)malloc(sizeof(cmscp_functionsPhase));
}