-heap  0x6000000    /* ѿռС,öѴСΪ0x600000ֽ  */   /*  0x1000 4KB 0x10000 64KB 0x100000 1M  0x1000000 16M 0x10000000 256M     */
-stack 0x6000000    /* ջռСջСΪ0x600000ֽ  */  /* 0x20000 128KB  0x40000 256KB  0x400000 4M */

MEMORY        /* ϵͳʵʵӲԴ  */
{
    /* o:original,ʾʼַ        l:lengthʾ洢ȣֽΪλ    LOCAL_L1P_SRAMʾԶĴ洢ռб    */
    /* Local L1P L1D */
    LOCAL_L1P_SRAM: o = 0x00E00000  l = 0x00008000   /* 32kB LOCAL L1P/SRAM */
    LOCAL_L1D_SRAM: o = 0x00F00000  l = 0x00008000   /* 32kB LOCAL L1D/SRAM */

    /* Local L2, 0.5~1MB*/
	LOCAL_L2_SRAM:  o = 0x00800000  l = 0x00080000   /* 512kB LOCAL L2/SRAM */
	/*
	VECTORS: 	    o = 0x00800000  l = 0x00000200
	LL2_RW_DATA: 	o = 0x00800200  l = 0x0003FE00
    */
    /* Multicore shared Memory */
    SHRAM:          o = 0x0C000000  l = 0x00400000   /* 4MB Multicore shared Memmory */

    /* EMIF Memory  */
    /* EMIF16_CS2:      o = 0x70000000 l = 0x04000000 */  /* 64MB EMIF16 CS2 Data Memory */
    /* EMIF16_CS3:      o = 0x74000000 l = 0x04000000 */  /* 64MB EMIF16 CS3 Data Memory */
    /* EMIF16_CS4:      o = 0x78000000 l = 0x04000000 */  /* 64MB EMIF16 CS4 Data Memory */
    /* EMIF16_CS5:      o = 0x7C000000 l = 0x04000000 */  /* 64MB EMIF16 CS5 Data Memory */


	/* External DDR3, upto 2GB per core */
	CORE0_DDR3:     o = 0x80000000  l = 0x10000000   /* 256MB DDR3 SDRAM for CORE0 */

	/* DDR3_CODE: 	    o = 0x80000000  l = 0x01000000 */  /*set memory protection attribitue as execution only*/
	/* DDR3_R_DATA: 	o = 0x81000000  l = 0x01000000 */	 /*set memory protection attribitue as read only*/
	/* DDR3_RW_DATA: 	o = 0x82000000  l = 0x20000000 */  /*set memory protection attribitue as read/write*/

}

SECTIONS      /* Ρζλ */
{
	.text         >    CORE0_DDR3     /* ų  */
	.cinit        >    CORE0_DDR3     /* ųеıֵͳ  */
	.pinit        >    CORE0_DDR3     /* ȫֹC++бȫֶĹ캯 */
	.const        >    CORE0_DDR3     /* ųеַ㳣constĳ  */
	.switch       >    CORE0_DDR3     /* ųswitchתַ  */
	.stack        >    CORE0_DDR3     /* Ϊϵͳջ洢ռ䣬ڱ淵صַĲݡ洢ֲͱм  */
	.tdata        >    CORE0_DDR3

	GROUP
	{
		.neardata
		.rodata                       /*   */
		.bss                          /* Ϊеȫֺ;̬洢ռ  */
	} 		       >    CORE0_DDR3

	.far           >    CORE0_DDR3    /* Ϊfarȫֺ;̬ռ  */
	.fardata       >    CORE0_DDR3    /*   */
	.cio           >    CORE0_DDR3    /*   */
	.sysmem        >    CORE0_DDR3    /* ڳеmalloccallocrealoc̬洢ռ  */
	.init_array    >    CORE0_DDR3
	.c6xabi.extab  >	CORE0_DDR3
	.c6xabi.exidx  >	CORE0_DDR3
	.TI.tls_init   >    CORE0_DDR3

}


