/**
 * @file csocp_iter.h
 * @brief 迭代(iterative)模块
 * This file implements iterative module.
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#ifndef __CSOCP_ITER_H__
#define __COSPC_ITER_H__

#include "csocp_config.h"

/** 更新属性 Update attributes */
void c_iter_updateattr(csocp_prob *prob);

/** 更新KKT系统 Update KKT system */
c_int c_iter_updatekkt(csocp_prob *prob);

#endif
