/**
 * @file tool_print.h
 * @brief 实现信息打印模块
 * This file implements message print module.
 * @version 0.1
 * @date 2021-09-17
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#ifndef __TOOL_PRINT_H__
#define __TOOL_PRINT_H__

#ifdef CSOCP_WITH_PRINT
#include <stdio.h>
#ifdef MATLAB_MEX_FILE
#include "mex.h"
#define c_print mexPrintf
#else
#define c_print printf
#endif
#else
#define c_print(...)
#endif

#endif
