#ifndef __CSOCP_CONFIG_H__
#define __CSOCP_CONFIG_H__

// Comment the following line to disable timer
#define CSOCP_WITH_TIMER 1

// Comment the following line to disable walltime
#ifdef LUOYC
#define CSOCP_WITH_WALLTIME 1
#endif

// Comment this line to disable log display
#define CSOCP_WITH_PRINT 1

// Comment the following line to disable this module
// #define CSOCP_WITH_INTERRUPT 1

// Coment the following line to disable debug tools
// #define CSOCP_WITH_DEBUG 1

// Comment the following line to disable dump data
// #define CSOCP_WITH_DUMP 1

// Comment the following line to disable statistics
#define CSOCP_WITH_STATS 1

// Comment the following line to disable copy problem
// #define CSOCP_WITH_COPYPROB 1

// Comment the following line to use in PC
// #define CSOCP_WITH_C6678 1

// Comment the folloing line to use ECOS settings
// #define CSOCP_WITH_ECOS 1

/* Infinity constant */
#define CSOCP_INFINITY +1e100

/* Type redefinition for types */
typedef double c_real;
typedef int c_int;

/* Forward declaration */
typedef struct c_attr_s c_attr;
typedef struct c_param_s c_param;
typedef struct c_buffer_s c_buffer;

typedef struct c_spmat_s c_spmat;

typedef struct c_lp_s c_lp;
typedef struct c_soc_s c_soc;
typedef struct c_cone_s c_cone;

typedef struct c_kkt_s c_kkt;

typedef struct c_prob_s csocp_prob;

#endif
