/**
 * This is the definition of buffer struct in CSOCP solver
 *
 * For better code engineering.
 */

#ifndef __STRUCT_BUFFER_H__
#define __STRUCT_BUFFER_H__

#include "csocp_config.h"

/* Definition of buffer */
struct c_buffer_s {
  c_int isize; /* Size of integer buffer */
  c_int ibeg;  /* Begin index of integer buffer */
  c_int *ibuf; /* Integer buffer */

  c_int dsize;  /* Size of double buffer */
  c_int dbeg;   /* Begin index of double buffer */
  c_real *dbuf; /* Double buffer */
};

#endif
